// port série dans nano Demon/gestionSerie.c
/**************************************************/
/********* VANDERMERSH / RIBREAU ******************/
/***************IMA4/2013**************************/
/**************************************************/



#include <MsTimer2.h> // inclusion de la librairie Timer2
#include <Wire.h> // inclusion librairie Wire pour lecture boussolle

#define PINAL 10
#define PINWMD 7
#define PINWMG 12
#define PINAVMOTD 8
#define PINARMOTD 9
#define PINAVMOTG 11
#define PINARMOTG 13

#define RELBAT 45 //45 //relais batterie pour capteur tension
#define INBAT A8//A8 // analog input pour batterie

//definition des pin pour les capteurs IR

//IR AVANT
#define CAP1 A1

#define CAP2 A2
#define CAP3 A3
#define CAP4 A4
//IR ARRIERE
#define CAP5 A5
#define CAP6 A6 //A6


///////////BOUSSOLE//////////////
// i2C Boussoles///

#define REF_AV 420 //reference valeur declenchement capteur IR avant  
#define REF_AR 320.0









//reference valeur declenchement capteur IR arrière 
#define vit_URG 30 // vitesse de recul après arret urgence
#define VIT_ROT 30 // vitesse des rotations

double VIT_AV = 30.00; // vitesse de référence avant
double VIT_AR = 40.00; // vitesse de référence arrière

long REF_cpt_crtl_90 = 250;
long REF_cpt_crtl_45 = 70;   

int mode=0;
char mo='i';
float val = 128;
int  val_ini = 3;  
double bat;
double vit_reg=5;
boolean REG_activate = 1 ; // régulateur activer seulement en cas d'un premier démarrage. Car sinon repars toujours de la valeur min a chaque boucle de loop
boolean M_avant = 0, M_arriere = 0, AR_URG = 0;
int cpt_URG=0;
int ang_d=0; // angle de rotation
int ang_g=0; // angle de rotation
char octetPC='i';
int cpt_urg = 0;
int reac_urg = 0;

///BOUSSOLE//////
float myres=0; // 0 à 3599 en degrée, converti dans la fct lecture_boussole en 0 à 360 degré
byte MSB;
byte LSB;
float angle_traj_actuel=0; // angle de la trajectoire en cours, permet la comparaison
int b_compare=0; //int car permet lors de la division de suppimer dixieme de degré car n'est pas assez prescis

int b_reg_g=0, b_reg_d=0;
int VAL_b_reg = 8;
int cpt_ctrl_boussole = 0;



void setup(){
  Serial.begin(9600); 
  Wire.begin();


  //gestion des variateurs
  pinMode(PINAL, OUTPUT);
  pinMode(PINWMD, OUTPUT);
  pinMode(PINWMG, OUTPUT);
  pinMode(PINAVMOTD, OUTPUT);
  pinMode(PINARMOTD, OUTPUT);
  pinMode(PINAVMOTG, OUTPUT);
  pinMode(PINARMOTG, OUTPUT);

  digitalWrite(PINAVMOTD, LOW);
  digitalWrite(PINARMOTD, LOW);
  digitalWrite(PINAVMOTG, LOW);
  digitalWrite(PINARMOTG, LOW);

  //gestion des capteur
  pinMode(CAP1, INPUT);
  pinMode(CAP2, INPUT);
  pinMode(CAP3, INPUT);
  pinMode(CAP4, INPUT);
  pinMode(CAP5, INPUT);
  pinMode(CAP6, INPUT);

  //gestion batterie
  pinMode(INBAT, INPUT);
  pinMode(RELBAT, OUTPUT); //pilote le relais du capteur de batterie
  digitalWrite(RELBAT, LOW);





  // initialisation interruption Timer 2
  MsTimer2::set(60000, interrupTimer2); // période 60000ms soit 60 sec
  MsTimer2::start(); // active Timer 2 
}


void loop(){
  float capt1=0;
  float capt2=0;
  float capt3=0;
  float capt4=0;
  float capt5=0;
  float capt6=0;


  //lecture port serie
  if( Serial.available()>0){


    octetPC= Serial.read(); //si via pc embarqué

    angle_traj_actuel = myres;
    if (reac_urg ==0){
      cpt_urg = 0;
    }
  }

  attribution_MO();

  capt1=analogRead(CAP1);
  capt2=analogRead(CAP2);
  capt3=analogRead(CAP3);
  capt4=analogRead(CAP4);
bouclesecu:
  capt5=analogRead(CAP5);
  capt6=analogRead(CAP6);
  delay(10);

  //GERE le recul de l'arret d'urgence

  if (AR_URG==1){
    int i=0;
    for (i=0;i<250;i=i+1){
      capt5=analogRead(CAP5);
      capt6=analogRead(CAP6);
      delay(10);
      if ((capt5>REF_AR)&&(capt6>REF_AR)){
        mo='s';
        stop_droit();
        stop_gauche();
        AR_URG=0;
        reac_urg = 0;
        goto fin_MA; 
      }
      else{
        recule_droit(vit_URG);
        recule_gauche(vit_URG);
        mo='r';
      }    
    }

fin_MA:    
    cpt_URG=0;
    mo='s';
    AR_URG=0;
    reac_urg = 0;
  }




  //Analyse les capteurs pour déclencher l'arret d'urgence au besoin
  if (M_avant==1){
    if ((capt1<REF_AV)&&(capt2<REF_AV)&&(capt3<REF_AV)&&(capt4<REF_AV)){
    }
    else{
      if (AR_URG != 1){
        stop_droit();
        stop_gauche();
        delay(2000);  // défini la durée avant la marche arrière de l'arret d'urgence
        M_avant=0;
        M_arriere=1;
        AR_URG=1;
        mo='s';
        octetPC='s';
        reac_urg = 1;

        if(cpt_urg != 0){
          mo='s';
        }
        else{
          Serial.print("s");
          cpt_urg=cpt_urg+1;
        }
      }
      goto bouclesecu;



    }
  }
  if(M_arriere==1){
    if ((capt5<REF_AR)&&(capt6<REF_AR)){
    }
    else{
      stop_droit();
      stop_gauche();
      mo='s';
      octetPC='s';
      reac_urg = 1;

      if(cpt_urg != 0){
        mo='s';
      }
      else{
        Serial.print("s");
        cpt_urg=cpt_urg+1;
      }
    }
  }
  /////////////////////////////////////////////////////////////////////////
  //envoie une tension sur l'entrée de detection de courant (fils jaune)
  analogWrite(PINAL,75);
  ///////////////////////////////////////////////////////////////////////// 

  ////////////////LECTURE BOUSSOLE, STOCKAGE DANS myres////////////////////
  lecture_boussole();
  /////////////////////////////////////////////////////////////////////////

  if (mo=='i'){
    initialisation();
    //mo='a';
    delay(2000);
  }
  else{ 
    if (mo=='a'){ // avance vitesse maxi
      // stop_droit();
      // stop_gauche();

      ///////////////////////////////////////////////////////////
      //////////////CORRECTION VIA BOUSSOLE//////////////////////
      b_compare = angle_traj_actuel - myres;
      if(b_compare==0){
        b_reg_d=0;
        b_reg_g=0;
      }
      else{
        if(b_compare<0){  //le robot par alors à gauche
          b_reg_d=0;
          b_reg_g=VAL_b_reg;
        }
        else{  //le robot par donc à droite
          b_reg_d=VAL_b_reg;
          b_reg_g=0;
        }

      }
      ///////////////////////////////////////////////////////////


      //permet de soulager les moteurs au début
      vit_reg = fonction_reg(vit_reg,VIT_AV);//crée une rampe d'accélération
      avance_droit(vit_reg + b_reg_d );
      avance_gauche(vit_reg + b_reg_g );  //+5 corrige decallage
      M_avant = 1;
      M_arriere = 0;
      delay(10);  /// origine 1000
      mo='a';

    }
    if(mo=='r'){ //recule maxi

      vit_reg = fonction_reg(vit_reg,VIT_AR);
      recule_droit(vit_reg);
      recule_gauche(vit_reg);
      M_avant = 0;
      M_arriere = 1;
      delay(10); 

      mo='r';

    }
    if(mo=='s'){
      stop_droit();
      stop_gauche();
      mo='s';
      octetPC='s';
      AR_URG=0; //////////////////////////////A SUPPRIMER SINON KINNECT REPREND CONTROLE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! A GARDER SI COMMANDE AU PC

    }
    if(mo=='t'){
      //tourne a droite en avançant
      avance_droit(30);
      avance_gauche(15);
      mo='t';
    }
    if(mo=='y'){
      //tourne a gauche en avançant
      avance_droit(15);
      avance_gauche(30);
      mo='y';
    }
    if(mo=='p'){
      //rotation gauche
      avance_gauche(VIT_ROT);
      recule_droit(VIT_ROT);
    }
    if(mo=='o'){
      //rotation droite
      avance_droit(VIT_ROT);
      recule_gauche(VIT_ROT);

    }

    if(mo=='w'){// rotation 90degrée droite
      b_compare = angle_traj_actuel - myres;
      b_compare= sqrt(b_compare*b_compare); // fait la valeur absolue de b_compare
      b_compare=b_compare/10;
      while((90-b_compare>0)&&(cpt_ctrl_boussole<REF_cpt_crtl_90)){
        //rotation droite 90
        avance_droit(VIT_ROT);
        recule_gauche(VIT_ROT);
        cpt_ctrl_boussole=cpt_ctrl_boussole+1;
        delay(10);
      }
      mo='s';
      octetPC='s';
      cpt_ctrl_boussole=0;
    }


    if(mo=='x'){//rotation 90degrée gauche
      b_compare = angle_traj_actuel - myres;
      b_compare= sqrt(b_compare*b_compare); // fait la valeur absolue de b_compare
      b_compare=b_compare/10;
      while((90-b_compare>0)&&(cpt_ctrl_boussole<REF_cpt_crtl_90)){
        //rotation gauche
        avance_gauche(VIT_ROT);
        recule_droit(VIT_ROT);
        cpt_ctrl_boussole=cpt_ctrl_boussole+1;
        delay(10);
      }
      mo='s';
      octetPC='s';
      cpt_ctrl_boussole=0;
    }

    if(mo=='v'){//rotation 45degrée gauche
      b_compare = angle_traj_actuel - myres;
      b_compare= sqrt(b_compare*b_compare); // fait la valeur absolue de b_compare
      b_compare=b_compare/10;
      while((45-b_compare>0)&&(cpt_ctrl_boussole<REF_cpt_crtl_45)){
        //rotation gauche
        avance_gauche(VIT_ROT);
        recule_droit(VIT_ROT);
        cpt_ctrl_boussole=cpt_ctrl_boussole+1;
        delay(10);
      }
      mo='s';
      octetPC='s';
      cpt_ctrl_boussole=0;
    }

    if(mo=='c'){//rotation 45degrée droite
      b_compare = angle_traj_actuel - myres;
      b_compare= sqrt(b_compare*b_compare); // fait la valeur absolue de b_compare
      b_compare=b_compare/10;
      while((45-b_compare>0)&&(cpt_ctrl_boussole<REF_cpt_crtl_45)){
        //rotation droite 45
        avance_droit(VIT_ROT);
        recule_gauche(VIT_ROT);
        cpt_ctrl_boussole=cpt_ctrl_boussole+1;
        delay(10);
      }
      mo='s';
      octetPC='s';
      cpt_ctrl_boussole=0;

    }

  }


}

void initialisation(){
  digitalWrite(PINAVMOTD, LOW);
  digitalWrite(PINARMOTD, LOW);
  digitalWrite(PINAVMOTG, LOW);
  digitalWrite(PINARMOTG, LOW);
  analogWrite(PINWMD,val_ini);
  analogWrite(PINWMG,val_ini);
}



void avance_droit(float vit){
  digitalWrite(PINARMOTD, LOW);
  digitalWrite(PINAVMOTD, HIGH);
  analogWrite(PINWMD,vit);
}

void recule_droit(float vit){
  digitalWrite(PINAVMOTD, LOW);
  digitalWrite(PINARMOTD, HIGH);
  analogWrite(PINWMD,vit);
}

void avance_gauche(float vit){
  digitalWrite(PINARMOTG, LOW);
  digitalWrite(PINAVMOTG, HIGH);
  analogWrite(PINWMG,vit);

}

void recule_gauche(float vit){
  digitalWrite(PINAVMOTG, LOW);
  digitalWrite(PINARMOTG, HIGH);
  analogWrite(PINWMG,vit);

}

void stop_droit(){
  digitalWrite(PINAVMOTD, LOW);
  digitalWrite(PINARMOTD, LOW);
}

void stop_gauche(){
  digitalWrite(PINAVMOTG, LOW);
  digitalWrite(PINARMOTG, LOW);
}


void info_bat(){
  if(bat>1020){
    // Serial.println("BATTERIE: 100%");
    Serial.print("p");
    delay(50); /// origine 500
  }
  else{
    if(bat>996){
      //   Serial.println("BATTERIE: 75%");
      Serial.print("o");
      delay(50);
    }
    else{
      if(bat>970){
        //  Serial.println("BATTERIE: 50%");
        Serial.print("i");
        delay(50);
      }
      else{
        if(bat>958){
          //  Serial.println("BATTERIE: 25%");
          Serial.print("u");
          delay(50);

        } 
        else{
          if(bat>880){
            //  Serial.println("BATTERIE: 00%");
            Serial.print("y");
            delay(50);

          }
          else{
            // Serial.println("BATTERIE: HS");
            Serial.print("t");
            delay(50);

          }
        }
      }  
    }
  }
}


void interrupTimer2() { // debut de la fonction d'interruption Timer2
  static boolean output = HIGH;
  digitalWrite(RELBAT, output);
  delay(80000); // permet de faire le relevé de manière fiable, laisse le temps...
  bat=analogRead(INBAT);
  info_bat();

  ///MEMENTO///
  //100% => 25.6v => 4.987v => 1020can
  //75% => 24.95v  => 4.86v => 996can
  //50% => 24.3v => 4.734v => 970can
  //25% => 24v => 4.675v => 958can
  //0% => 22v => 4.286v => 880can


}

void attribution_MO(){
  if(octetPC=='s'){ //STOP
    mo='s';
    angle_traj_actuel = myres;
  } 
  if(octetPC=='a'){ //AVANCE RAPIDE
    mo='a';
    VIT_AV=35;
    angle_traj_actuel = myres;
  } 
  if(octetPC=='q'){ //AVANCE LENTE
    mo='a';
    VIT_AV=25;
    angle_traj_actuel = myres;
  }
  if(octetPC=='r'){ //RECULE RAPIDE
    mo='r';
    VIT_AR=40;
    angle_traj_actuel = myres;
  }
  if(octetPC=='d'){ //RECULE LENTE
    mo='r';
    VIT_AR=25;
    angle_traj_actuel = myres;
  }
  if(octetPC=='x'){ //tourne droite 90°
    mo='x';
    ang_d=90;
    angle_traj_actuel = myres;
  }
  if(octetPC=='w'){ //tourne gauche 90°
    mo='w';
    ang_g=90;
    angle_traj_actuel = myres;
  }
  if(octetPC=='v'){ //tourne droite 45°
    mo='v';
    ang_d=45;
    angle_traj_actuel = myres;
  }
  if(octetPC=='c'){ //tourne gauche 45°
    mo='c';
    ang_g=45;
    angle_traj_actuel = myres;
  }
  if(octetPC=='t'){ //courbe gauche
    mo='t';
  }
  if(octetPC=='y'){ //courbe droite
    mo='y';
  }

}

double fonction_reg(double reg, double VIT){

  if(reg<VIT){
    reg=reg+2; 
  }
  else{
    REG_activate = 0;
  }
  return reg;
}

void lecture_boussole(){
  Wire.beginTransmission(0x21);
  Wire.write("A");
  delay(100);
  Wire.requestFrom(0x21,2);
  MSB = Wire.read(); //Lecture de 0 à 3599
  LSB = Wire.read();
  Wire.endTransmission();
  myres = ((MSB << 8) + LSB) / 10;

}




